VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.2#0"; "MSCOMCTL.OCX"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   5580
   ClientLeft      =   60
   ClientTop       =   405
   ClientWidth     =   6090
   LinkTopic       =   "Form1"
   ScaleHeight     =   5580
   ScaleWidth      =   6090
   StartUpPosition =   3  'Windows-Standard
   Begin MSComctlLib.TreeView TreeView1 
      Height          =   4065
      Left            =   150
      TabIndex        =   1
      Top             =   210
      Width           =   5745
      _ExtentX        =   10134
      _ExtentY        =   7170
      _Version        =   393217
      Style           =   7
      Appearance      =   1
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   1005
      Left            =   150
      TabIndex        =   0
      Top             =   4470
      Width           =   2085
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const TV_FIRST As Long = &H1100
Private Const TVM_INSERTITEMA As Long = (TV_FIRST + 0)
Private Const TVM_SETIMAGELIST As Long = (TV_FIRST + 9)
Private Const TVSIL_NORMAL As Long = &H0
Private Const TVIF_CHILDREN As Long = &H40
Private Const TVIF_IMAGE As Long = &H2
Private Const TVIF_SELECTEDIMAGE As Long = &H20
Private Const TVIF_TEXT As Long = &H1
Private Const TVI_ROOT As Long = -&H10000


Private Type TVITEM
    mask As Long
    hItem As Long
    state As Long
    stateMask As Long
    pszText As String
    cchTextMax As Long
    iImage As Long
    iSelectedImage As Long
    cChildren As Long
    lParam As Long
End Type

Private Type TVINSERTSTRUCT
    hParent As Long
    hInsertAfter As Long
    Item As TVITEM
End Type

Private Declare Function SendMessage Lib "user32.dll" _
                         Alias "SendMessageA" ( _
                         ByVal hWnd As Long, _
                         ByVal wMsg As Long, _
                         ByVal wParam As Long, _
                         ByRef lParam As Any) As Long

Private Declare Function DestroyIcon Lib "user32.dll" ( _
                         ByVal hIcon As Long) As Long

Private bILInit As Boolean
Private IImageList As clsIImageList
Private cImageList As clsImageList

Private Sub Command1_Click()

    Dim hIcon As Long
    Dim lIconIndex As Long
    Dim lSysIconIndex As Long
    Dim Item As TVITEM
    Dim InsertItem As TVINSERTSTRUCT
    
    ' IconIndex aus der SystemImageList ermitteln
    lSysIconIndex = GetIconIndex("C:\")

    ' ist ein Index vorhanden
    If lSysIconIndex > 0 Then

        ' sind beide ImageList initialisiert
        If bILInit = True Then

            ' wenn das Icon aus der SystemImageList noch nicht in der
            ' eigenen ImageList vorhanden ist
            If cImageList.GetKey(lSysIconIndex) = -1 Then
            
                'Debug.Print "Add new Icon"
                
                ' Handle des Icon aus der SystemImageList ermitteln
                hIcon = IImageList.GetIcon(lSysIconIndex, CLR_DEFAULT)
                
                ' ist ein Handle vorhanden
                If hIcon <> 0 Then
                
                    ' Icon aus der SystemImageList der eigenen ImageList hinzufgen
                    lIconIndex = cImageList.AddIcon(hIcon)
                    
                    ' IconIndex der eigenen Imagelist passend zum IconIndex
                    ' der SystemImageList speichern
                    Call cImageList.SetKey(lIconIndex, lSysIconIndex)
                    
                    ' Handle wieder freigeben
                    Call DestroyIcon(hIcon)
                    
                End If
                
            Else
                
                'Debug.Print "Icon exist"
            
                ' ist das Icon aus der SystemImageList bereits in der
                ' eigenen ImageList vorhanden
                
                ' IconIndex aus der eigenen Imagelist passend zum
                ' IconIndex der SystemImageList ermitteln
                lIconIndex = cImageList.GetKey(lSysIconIndex)
                
            End If

            ' TreeView-Node
            With Item
                .pszText = "TestNode"
                .cchTextMax = LenB(.pszText)
                .iImage = lIconIndex
                .iSelectedImage = lIconIndex
                .mask = TVIF_TEXT Or TVIF_IMAGE Or TVIF_SELECTEDIMAGE
            End With
                
            With InsertItem
                .Item = Item
                .hParent = TVI_ROOT
                .hInsertAfter = TVI_ROOT
            End With
                
            ' TreeView-Node hinzufgen
            Call SendMessage(TreeView1.hWnd, TVM_INSERTITEMA, 0&, InsertItem)
                
        End If
    End If

End Sub

Private Sub Form_Load()
    
    Me.Show
    
    DoEvents
    
    Dim pIImageList As Long

    bILInit = False

    ' Pointer auf die SystemImageList holen, 16px x 16px
    If SHGetImageList(SHIL_SMALL, IIDtoLong(IID_IImageList), pIImageList) = S_OK _
        Then

        ' SystemImageList initialisieren
        Set IImageList = New clsIImageList
        Call IImageList.Initialize(pIImageList)

        ' eigene ImageList erstellen, 16px x 16px
        Set cImageList = New clsImageList
        If cImageList.CreateImageList(16, 16) = True Then
            
            With TreeView1
                .HideSelection = False
                .LineStyle = tvwRootLines
                .Style = tvwTreelinesPlusMinusPictureText
            End With
            
            ' eigene ImageList der TreeView zuweisen
            Call SendMessage(TreeView1.hWnd, TVM_SETIMAGELIST, TVSIL_NORMAL, ByVal cImageList.hImageList)
            
            bILInit = True

        End If
    End If

End Sub

Private Sub Form_Unload(Cancel As Integer)

    If bILInit = True Then

        Set IImageList = Nothing
        Set cImageList = Nothing

    End If

End Sub

