VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsImageList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Const ILC_COLOR32 As Long = &H20

Private Declare Sub InitCommonControls Lib "comctl32.dll" ()

Private Declare Function ImageList_Create Lib "comctl32.dll" ( _
                         ByVal cx As Long, _
                         ByVal cy As Long, _
                         ByVal flags As Long, _
                         ByVal cInitial As Long, _
                         ByVal cGrow As Long) As Long

Private Declare Function ImageList_Destroy Lib "comctl32.dll" ( _
                         ByVal himl As Long) As Long

Private Declare Function ImageList_GetImageCount Lib "comctl32.dll" ( _
                         ByVal himl As Long) As Long

Private Declare Function ImageList_ReplaceIcon Lib "comctl32.dll" ( _
                         ByVal himl As Long, _
                         ByVal i As Long, _
                         ByVal hIcon As Long) As Long

Private m_Key As New Collection
Private m_hImageList As Long

Public Property Get hImageList() As Long

    hImageList = m_hImageList
    
End Property

Public Function GetKey(ByVal Key As Long) As Long
    On Error GoTo NotFound
    GetKey = CLng(m_Key.Item(CStr(Key)))
    Exit Function
NotFound:
    GetKey = -1
End Function

Public Sub SetKey(ByVal Value As Long, ByVal Key As String)
    Call m_Key.Add(CStr(Value), CStr(Key))
End Sub

Public Function CreateImageList(ByVal cx As Long, ByVal cy As Long) As Boolean
    
    Dim bRet As Boolean
    
    bRet = False
    
    m_hImageList = ImageList_Create(cx, cy, ILC_COLOR32, 0&, 0&)
    
    If m_hImageList <> 0 Then
    
        bRet = True
    
    End If
    
    CreateImageList = bRet
    
End Function

Public Function GetImageCount() As Long

    GetImageCount = ImageList_GetImageCount(m_hImageList)

End Function

Public Function AddIcon(ByVal hIcon As Long, Optional ByVal index As Long = -1) As Long
    
    AddIcon = ImageList_ReplaceIcon(m_hImageList, index, hIcon)

End Function

Private Sub Class_Initialize()
    
    Call InitCommonControls

End Sub

Private Sub Class_Terminate()

    If m_hImageList <> 0 Then
        
        Call ImageList_Destroy(m_hImageList)
    
    End If

End Sub
