VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsSysImageList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Enum ILCopyFlags
    ILCF_MOVE = &H0
    ILCF_SWAP = &H1
End Enum

Public Enum ILReadWriteExFlags
    ILP_NORMAL = &H0
    ILP_DOWNLEVEL = &H1
End Enum

Public Enum ILCreateFlags
    ILC_COLOR = &H0
    ILC_MASK = &H1
    ILC_COLOR4 = &H4
    ILC_COLOR8 = &H8
    ILC_COLOR16 = &H10
    ILC_COLOR24 = &H18
    ILC_COLOR32 = &H20
    ILC_COLORDDB = &HFE
    ILC_PALETTE = &H800
    ILC_MIRROR = &H2000
    ILC_PERITEMMIRROR = &H8000
    ILC_ORIGINALSIZE = &H10000
    ILC_HIGHQUALITYSCALE = &H20000
End Enum

Public Enum ILDrawFlags
    ILD_NORMAL = &H0
    ILD_TRANSPARENT = &H1
    ILD_BLEND25 = &H2
    ILD_BLEND50 = &H4
    ILD_MASK = &H10
    ILD_IMAGE = &H20
    ILD_ROP = &H40
    ILD_OVERLAYMASK = &HF00&
    ILD_FOCUS = ILD_BLEND25
    ILD_BLEND = ILD_BLEND50
    ILD_SELECTED = ILD_BLEND50
End Enum

Public Enum ILStateFlags
    ILS_NORMAL = &H0
    ILS_GLOW = &H1
    ILS_SHADOW = &H2
    ILS_SATURATE = &H4
    ILS_ALPHA = &H8
End Enum

' ---=== Kernel32 Deklaration ===---
Private Declare Sub CopyMemory Lib "kernel32.dll" _
                    Alias "RtlMoveMemory" ( _
                    ByRef Destination As Any, _
                    ByRef Source As Any, _
                    ByVal Length As Long)

' ---=== Comctl32 Deklaration ===---
Private Declare Sub InitCommonControls Lib "comctl32.dll" ()

Private Declare Function ImageList_Add Lib "comctl32.dll" ( _
                         ByVal himl As Long, _
                         ByVal hbmImage As Long, _
                         ByVal hbmMask As Long) As Long

Private Declare Function ImageList_AddIcon Lib "comctl32.dll" ( _
                         ByVal himl As Long, _
                         ByVal hicon As Long) As Long

Private Declare Function ImageList_AddMasked Lib "comctl32.dll" ( _
                         ByVal himl As Long, _
                         ByVal hbmImage As Long, _
                         ByVal crMask As Long) As Long

Private Declare Function ImageList_BeginDrag Lib "comctl32.dll" ( _
                         ByVal himlTrack As Long, _
                         ByVal iTrack As Long, _
                         ByVal dxHotspot As Long, _
                         ByVal dyHotspot As Long) As Long

Private Declare Function ImageList_Copy Lib "comctl32.dll" ( _
                         ByVal himlDst As Long, _
                         ByVal iDst As Long, _
                         ByVal himlSrc As Long, _
                         ByVal iSrc As Long, _
                         ByVal uFlags As Long) As Long

Private Declare Function ImageList_Create Lib "comctl32.dll" ( _
                         ByVal cx As Long, _
                         ByVal cy As Long, _
                         ByVal flags As Long, _
                         ByVal cInitial As Long, _
                         ByVal cGrow As Long) As Long

Private Declare Function ImageList_Destroy Lib "comctl32.dll" ( _
                         ByVal himl As Long) As Long

Private Declare Function ImageList_DragEnter Lib "comctl32.dll" ( _
                         ByVal hwndLock As Long, _
                         ByVal x As Long, _
                         ByVal y As Long) As Long

Private Declare Function ImageList_DragLeave Lib "comctl32.dll" ( _
                         ByVal hwndLock As Long) As Long

Private Declare Function ImageList_DragMove Lib "comctl32.dll" ( _
                         ByVal x As Long, _
                         ByVal y As Long) As Long

Private Declare Function ImageList_DragShowNolock Lib "comctl32.dll" ( _
                         ByVal fShow As Long) As Long

Private Declare Function ImageList_Draw Lib "comctl32.dll" ( _
                         ByVal himl As Long, _
                         ByVal i As Long, _
                         ByVal hdcDst As Long, _
                         ByVal x As Long, _
                         ByVal y As Long, _
                         ByVal fStyle As Long) As Long

Private Declare Function ImageList_DrawEx Lib "comctl32.dll" ( _
                         ByVal himl As Long, _
                         ByVal i As Long, _
                         ByVal hdcDst As Long, _
                         ByVal x As Long, _
                         ByVal y As Long, _
                         ByVal dx As Long, _
                         ByVal dy As Long, _
                         ByVal rgbBk As Long, _
                         ByVal rgbFg As Long, _
                         ByVal fStyle As Long) As Long

Private Declare Function ImageList_DrawIndirect Lib "comctl32.dll" ( _
                         ByVal pimldp As Long) As Long

Private Declare Function ImageList_Duplicate Lib "comctl32.dll" ( _
                         ByVal himl As Long) As Long

Private Declare Sub ImageList_EndDrag Lib "comctl32.dll" ()

Private Declare Function ImageList_GetBkColor Lib "comctl32.dll" ( _
                         ByVal himl As Long) As Long

Private Declare Function ImageList_GetDragImage Lib "comctl32.dll" ( _
                         ByVal ppt As Long, _
                         ByVal pptHotspot As Long) As Long

Private Declare Function ImageList_GetIcon Lib "comctl32.dll" ( _
                         ByVal himl As Long, _
                         ByVal i As Long, _
                         ByVal flags As Long) As Long

Private Declare Function ImageList_GetFlags Lib "comctl32.dll" ( _
                         ByVal himl As Long, _
                         ByRef flags As Long) As Long

Private Declare Function ImageList_GetIconSize Lib "comctl32.dll" ( _
                         ByVal himl As Long, _
                         ByRef cx As Long, _
                         ByRef cy As Long) As Long

Private Declare Function ImageList_GetImageCount Lib "comctl32.dll" ( _
                         ByVal himl As Long) As Long

Private Declare Function ImageList_GetImageInfo Lib "comctl32.dll" ( _
                         ByVal himl As Long, _
                         ByVal i As Long, _
                         ByVal pImageInfo As Long) As Long

Private Declare Function ImageList_GetImageRect Lib "comctl32.dll" ( _
                         ByVal himl As Long, _
                         ByVal i As Long, _
                         ByVal pImageRect As Long) As Long

Private Declare Function ImageList_LoadImage Lib "comctl32.dll" ( _
                         ByVal hi As Long, _
                         ByVal lpbmp As String, _
                         ByVal cx As Long, _
                         ByVal cGrow As Long, _
                         ByVal crMask As Long, _
                         ByVal uType As Long, _
                         ByVal uFlags As Long) As Long

Private Declare Function ImageList_LoadImageA Lib "comctl32.dll" ( _
                         ByVal hi As Long, _
                         ByVal lpbmp As String, _
                         ByVal cx As Long, _
                         ByVal cGrow As Long, _
                         ByVal crMask As Long, _
                         ByVal uType As Long, _
                         ByVal uFlags As Long) As Long

Private Declare Function ImageList_LoadImageW Lib "comctl32.dll" ( _
                         ByVal hi As Long, _
                         ByVal lpbmp As Long, _
                         ByVal cx As Long, _
                         ByVal cGrow As Long, _
                         ByVal crMask As Long, _
                         ByVal uType As Long, _
                         ByVal uFlags As Long) As Long

Private Declare Function ImageList_Merge Lib "comctl32.dll" ( _
                         ByVal himl1 As Long, _
                         ByVal i1 As Long, _
                         ByVal himl2 As Long, _
                         ByVal i2 As Long, _
                         ByVal dx As Long, _
                         ByVal dy As Long) As Long

Private Declare Function ImageList_Read Lib "comctl32.dll" ( _
                         ByVal pstm As Long) As Long

Private Declare Function ImageList_ReadEx Lib "comctl32.dll" ( _
                         ByVal dwFlags As Long, _
                         ByVal pstm As Long, _
                         ByRef riid As Long, _
                         ByRef ppv As Long) As Long

Private Declare Function ImageList_Remove Lib "comctl32.dll" ( _
                         ByVal himl As Long, _
                         ByVal i As Long) As Long

Private Declare Function ImageList_Replace Lib "comctl32.dll" ( _
                         ByVal himl As Long, _
                         ByVal i As Long, _
                         ByVal hbmImage As Long, _
                         ByVal hbmMask As Long) As Long

Private Declare Function ImageList_ReplaceIcon Lib "comctl32.dll" ( _
                         ByVal himl As Long, _
                         ByVal i As Long, _
                         ByVal hicon As Long) As Long

Private Declare Function ImageList_SetBkColor Lib "comctl32.dll" ( _
                         ByVal himl As Long, _
                         ByVal clrBk As Long) As Long

Private Declare Function ImageList_SetColorTable Lib "comctl32.dll" ( _
                         ByVal himl As Long, _
                         ByVal start As Long, _
                         ByVal ilen As Long, _
                         ByVal prgb As Long) As Long

Private Declare Function ImageList_SetDragCursorImage Lib "comctl32.dll" ( _
                         ByVal himlDrag As Long, _
                         ByVal iDrag As Long, _
                         ByVal dxHotspot As Long, _
                         ByVal dyHotspot As Long) As Long

Private Declare Function ImageList_SetFilter Lib "comctl32.dll" ( _
                         ByVal himl As Long, _
                         ByVal i As Long, _
                         ByVal dwFilter As Long) As Long

Private Declare Function ImageList_SetFlags Lib "comctl32.dll" ( _
                         ByVal himl As Long, _
                         ByVal flags As Long) As Long

Private Declare Function ImageList_SetIconSize Lib "comctl32.dll" ( _
                         ByVal himl As Long, _
                         ByVal cx As Long, _
                         ByVal cy As Long) As Long

Private Declare Function ImageList_SetImageCount Lib "comctl32.dll" ( _
                         ByVal himl As Long, _
                         ByVal uNewCount As Long) As Long

Private Declare Function ImageList_SetOverlayImage Lib "comctl32.dll" ( _
                         ByVal himl As Long, _
                         ByVal iImage As Long, _
                         ByVal iOverlay As Long) As Long

Private Declare Function ImageList_Write Lib "comctl32.dll" ( _
                         ByVal himl As Long, _
                         ByVal pstm As Long) As Long

Private Declare Function ImageList_WriteEx Lib "comctl32.dll" ( _
                         ByVal himl As Long, _
                         ByVal dwFlags As Long, _
                         ByVal pstm As Long) As Long


' GetItemFlags
' GetOverlayImage

' ---=== Variablen ===---
Private m_hImageList As Long

Private Sub Class_Initialize()
    
    Call InitCommonControls
    
End Sub

Private Sub Class_Terminate()

    Call Destroy
    
End Sub

Public Function Add(ByVal hbmImage As Long, Optional ByVal hbmMask As Long = 0&) As Long
    
    If m_hImageList <> 0 Then
    
        Add = ImageList_Add(m_hImageList, hbmImage, hbmMask)
    
    End If

End Function

Public Function AddIcon(ByVal hicon As Long) As Long

    If m_hImageList <> 0 Then

        AddIcon = ImageList_AddIcon(m_hImageList, hicon)
    
    End If

End Function

Public Function ExtractIcon(ByVal i As Long) As Long

    ExtractIcon = GetIcon(i, ILD_NORMAL)

End Function

Public Function LoadBitmap(ByVal hi As Long, ByVal lpbmp As String, ByVal cx As _
    Long, ByVal cGrow As Long, ByVal crMask As Long) As Long

    Dim lFlags As Long

    If hi = 0& Then

        lFlags = LR_LOADFROMFILE

    Else

        lFlags = &H0

    End If

    LoadBitmap = ImageList_LoadImage(hi, lpbmp, cx, cGrow, crMask, IMAGE_BITMAP, _
        lFlags)

End Function

Public Function ReplaceIcon(ByVal hicon As Long, Optional ByVal i As Long = -1) As Long

    If m_hImageList <> 0 Then
    
        ReplaceIcon = ImageList_ReplaceIcon(m_hImageList, i, hicon)
    
    End If

End Function

Public Function SetOverlayImage(ByVal iImage As Long, ByVal iOverlay As Long) As Boolean

    If m_hImageList <> 0 Then

        SetOverlayImage = CBool(ImageList_ReplaceIcon(m_hImageList, iImage, iOverlay))
    
    End If

End Function

Public Function Replace(ByVal i As Long, ByVal hbmImage As Long, Optional ByVal _
    hbmMask As Long = 0&) As Boolean

    If m_hImageList <> 0 Then

        Replace = CBool(ImageList_Replace(m_hImageList, i, hbmImage, hbmMask))
    
    End If

End Function

Public Function AddMasked(ByVal hbmImage As Long, ByVal crMask As Long) As Long

    If m_hImageList <> 0 Then

        Replace = ImageList_AddMasked(m_hImageList, hbmImage, hbmMask)
    
    End If

End Function

Public Function Draw(ByVal i As Long, ByVal hdcDst As Long, ByVal x As Long, ByVal _
    y As Long, ByVal fStyle As ILDrawFlags) As Boolean

    If m_hImageList <> 0 Then

        Draw = CBool(ImageList_Draw(m_hImageList, i, hdcDst, x, y, fStyle))

    End If

End Function

Public Function DrawEx(ByVal i As Long, ByVal hdcDst As Long, ByVal x As Long, _
    ByVal y As Long, ByVal dx As Long, ByVal dy As Long, ByVal rgbBk As Long, ByVal _
    rgbFg As Long, ByVal fStyle As ILDrawFlags) As Boolean

    If m_hImageList <> 0 Then

        DrawEx = CBool(ImageList_DrawEx(m_hImageList, i, hdcDst, x, y, dx, dy, _
            rgbBk, rgbFg, fStyle))

    End If

End Function

Public Function DrawIndirect(ByVal pimldp As Long) As Boolean

    If m_hImageList <> 0 Then

        DrawIndirect = CBool(ImageList_DrawIndirect(pimldp))

    End If

End Function

Public Function Remove(ByVal i As Long) As Boolean

    If m_hImageList <> 0 Then

        Remove = CBool(ImageList_Remove(m_hImageList, i))

    End If

End Function

Public Sub Clear()

    Call RemoveAll

End Sub

Public Function RemoveAll() As Boolean

    Dim bRet As Boolean
    Dim lItem As Long
    Dim lCount As Long

    If m_hImageList <> 0 Then

        lCount = GetImageCount

        If lCount > 0 Then

            For lItem = 0 To lCount - 1

                bRet = CBool(ImageList_Remove(m_hImageList, lItem))

                If bRet = False Then

                    Exit For

                End If

            Next

        End If
    End If

    RemoveAll = bRet

End Function


Public Function GetIcon(ByVal i As Long, ByVal flags As ILDrawFlags) As Long

    If m_hImageList <> 0 Then

        GetIcon = ImageList_GetIcon(m_hImageList, i, flags)

    End If

End Function

Public Function GetImageInfo(ByVal i As Long, ByRef pImageInfo As Long) As Boolean

    If m_hImageList <> 0 Then

        GetImageInfo = CBool(ImageList_GetImageInfo(m_hImageList, i, pImageInfo))

    End If

End Function

Public Function GetImageRect(ByVal i As Long, ByRef prc As Long) As Boolean
    
    If m_hImageList <> 0 Then

        GetImageRect = CBool(ImageList_GetImageRect(m_hImageList, i, prc))
        
    End If
    
End Function

Public Function Copy(ByVal iDst As Long, ByVal himlSrc As Long, ByVal iSrc As Long, _
    ByVal uFlags As ILCopyFlags) As Boolean
    
    If m_hImageList <> 0 Then

        Copy = CBool(ImageList_Copy(m_hImageList, iDst, himlSrc, iSrc, uFlags))

    End If
    
End Function

Public Function Merge(ByVal i1 As Long, ByVal himl2 As Long, ByVal i2 As Long, _
    ByVal dx As Long, ByVal dy As Long) As Long

    If m_hImageList <> 0 Then

        Merge = ImageList_Merge(m_hImageList, i1, himl2, i2, dx, dy)

    End If

End Function

Public Function Clone() As Long

    If m_hImageList <> 0 Then

        Clone = ImageList_Duplicate(m_hImageList)

    End If

End Function

Public Function GetIconSize(ByRef cx As Long, ByRef cy As Long) As Boolean

    If m_hImageList <> 0 Then

        GetIconSize = CBool(ImageList_GetIconSize(m_hImageList, cx, cy))

    End If

End Function

Public Function SetIconSize(ByVal cx As Long, ByVal cy As Long) As Boolean

    If m_hImageList <> 0 Then

        SetIconSize = CBool(ImageList_SetIconSize(m_hImageList, cx, cy))

    End If

End Function

Public Function GetImageCount() As Long

    If m_hImageList <> 0 Then

        GetImageCount = ImageList_GetImageCount(m_hImageList)

    End If

End Function

Public Function SetImageCount(ByVal uNewCount As Long) As Boolean

    If m_hImageList <> 0 Then

        SetImageCount = CBool(ImageList_SetImageCount(m_hImageList, uNewCount))

    End If

End Function

Public Function SetBkColor(ByVal clrBk As Long) As Long

    If m_hImageList <> 0 Then

        SetBkColor = ImageList_SetBkColor(m_hImageList, clrBk)

    End If

End Function

Public Function GetBkColor() As Long

    If m_hImageList <> 0 Then

        GetBkColor = ImageList_GetBkColor(m_hImageList)

    End If

End Function

Public Function SetColorTable(ByVal start As Long, ByVal ilen As Long, ByVal prgb _
    As Long) As Long

    If m_hImageList <> 0 Then

        SetColorTable = ImageList_SetColorTable(m_hImageList, start, ilen, prgb)

    End If

End Function

Public Function BeginDrag(ByVal iTrack As Long, ByVal dxHotspot As Long, ByVal _
    dyHotspot As Long) As Boolean

    If m_hImageList <> 0 Then

        BeginDrag = CBool(ImageList_BeginDrag(m_hImageList, iTrack, dxHotspot, _
            dyHotspot))

    End If

End Function

Public Sub EndDrag()

    If m_hImageList <> 0 Then

        Call ImageList_EndDrag(m_hImageList)

    End If

End Sub

Public Function DragEnter(ByVal hwndLock As Long, ByVal x As Long, ByVal y As Long) _
    As Boolean
    
    If m_hImageList <> 0 Then

        DragEnter = CBool(ImageList_DragEnter(hwndLock, x, y))

    End If
    
End Function

Public Function DragLeave(ByVal hwndLock As Long) As Boolean

    If m_hImageList <> 0 Then

        DragLeave = CBool(ImageList_DragLeave(hwndLock))

    End If

End Function

Public Function DragMove(ByVal x As Long, ByVal y As Long) As Boolean

    If m_hImageList <> 0 Then

        DragMove = CBool(ImageList_DragMove(x, y))

    End If

End Function

Public Function SetDragCursorImage(ByVal himlDrag As Long, ByVal iDrag As Long, _
    ByVal dxHotspot As Long, ByVal dyHotspot As Long) As Boolean

    If m_hImageList <> 0 Then

        SetDragCursorImage = CBool(ImageList_SetDragCursorImage(himlDrag, iDrag, _
            dxHotspot, dyHotspot))

    End If

End Function

Public Function DragShowNolock(ByVal fShow As Boolean) As Boolean

    If m_hImageList <> 0 Then

        DragShowNolock = CBool(ImageList_DragShowNolock(CLng(fShow)))

    End If

End Function

Public Function GetDragImage(ByRef ppt As Long, ByRef pptHotspot As Long) As Long
    
    If m_hImageList <> 0 Then

        GetDragImage = ImageList_GetDragImage(ppt, pptHotspot)

    End If
    
End Function

Public Function ILRead(ByVal pstm As Long) As Long

    If m_hImageList <> 0 Then

        ILRead = ImageList_Read(pstm)

    End If

End Function

Public Function ILReadEx(ByVal dwFlags As ILReadWriteExFlags, ByVal pstm As _
    Long, ByRef riid As Long, ByRef ppv As Long) As Long

    If m_hImageList <> 0 Then

        ILReadEx = ImageList_ReadEx(dwFlags, pstm, riid, ppv)

    End If

End Function

Public Function ILWrite(ByVal pstm As Long) As Long

    If m_hImageList <> 0 Then

        ILWrite = ImageList_Write(m_hImageList, pstm)

    End If

End Function

Public Function ILWriteEx(ByVal dwFlags As ILReadWriteExFlags, ByVal pstm As Long) As Long

    If m_hImageList <> 0 Then

        ILWriteEx = ImageList_WriteEx(m_hImageList, dwFlags, pstm)

    End If

End Function

Public Function Create(ByVal cx As Long, ByVal cy As Long, ByVal flags As _
    ILCreateFlags, Optional ByVal cInitial As Long = 0&, Optional ByVal cGrow As _
    Long = 0&) As Boolean

    Dim bRet As Boolean

    bRet = False

    If m_hImageList = 0 Then

        m_hImageList = ImageList_Create(cx, cy, flags, cInitial, cGrow)

        If m_hImageList <> 0 Then

            bRet = True

        Else

            bRet = False

        End If

    Else

        bRet = False

    End If

    Create = bRet

End Function

Public Function Destroy() As Boolean

    If m_hImageList <> 0 Then
    
        If ImageList_Destroy(m_hImageList) <> 0 Then

            m_hImageList = 0
            Destroy = True

        End If
    End If

End Function

Public Property Get hImageList() As Long
    
    hImageList = m_hImageList

End Property

